Loading...
Searching...
No Matches
casacore::ArrayColumnBase Class Reference
tables package (libcasa_tables) » Tables_module

More...

`#include <ArrayColumnBase.h>`

## Public Member Functions

| ArrayColumnBase ()
| The default constructor creates a null object, i.e.
| ArrayColumnBase (const Table &, const String &columnName)
| Construct for the given column in the given table.
| ArrayColumnBase (const TableColumn &column)
| Construct from the given table column.
| ArrayColumnBase (const ArrayColumnBase &)
| Copy constructor (reference semantics).
| ~ArrayColumnBase ()
ArrayColumnBase & | operator= (const ArrayColumnBase &)
| Assignment uses reference semantics, thus works the same as function reference.
void | reference (const ArrayColumnBase &)
| Change the reference to another column.
uInt | ndim (rownr_t rownr) const
| Get the #dimensions of an array in a particular cell.
IPosition | shape (rownr_t rownr) const
| Get the shape of an array in a particular cell.
void | baseGet (rownr_t rownr, ArrayBase &array) const
| Counterparts of the acbGet() functions below not checking shapes, etc.
void | baseGetSlice (rownr_t rownr, const Slicer &arraySection, ArrayBase &array) const
void | acbGet (rownr_t rownr, ArrayBase &array, Bool resize) const
| Get the array value in a particular cell (i.e.
void | acbGetSlice (rownr_t rownr, const Slicer &arraySection, ArrayBase &array, Bool resize) const
| Get a slice of an N-dimensional array in a particular cell (i.e.
void | acbGetSlice (rownr_t rownr, const Vector< Vector< Slice > > &arraySlices, ArrayBase &arr, Bool resize) const
| Get an irregular slice of an N-dimensional array in a particular cell (i.e.
void | acbGetColumn (ArrayBase &array, Bool resize) const
| Get the array of all values in a column.
void | acbGetColumn (const Slicer &arraySection, ArrayBase &array, Bool resize) const
| Get regular slices from all arrays in the column.
void | acbGetColumn (const Vector< Vector< Slice > > &arraySection, ArrayBase &array, Bool resize) const
| Get irregular slices from all arrays in the column as given by the vectors of Slice objects.
void | acbGetColumnRange (const Slicer &rowRange, ArrayBase &arr, Bool resize) const
| Get the array of some values in a column.
void | acbGetColumnCells (const RefRows &rownrs, ArrayBase &arr, Bool resize) const
void | acbGetColumnRange (const Slicer &rowRange, const Slicer &arraySection, ArrayBase &arr, Bool resize) const
| Get slices from some arrays in a column.
void | acbGetColumnCells (const RefRows &rownrs, const Slicer &arraySection, ArrayBase &arr, Bool resize) const
void | acbGetColumnCells (const RefRows &rows, const ColumnSlicer &columnSlicer, ArrayBase &destination, Bool resize) const
| Get various slices from the given rows.
void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of the array in the given row.
void | setShape (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Try to store the array in a tiled way using the given tile shape.
void | basePut (rownr_t rownr, const ArrayBase &array)
| Counterparts of the acbPut() functions below not checking shapes, etc.
void | basePutSlice (rownr_t rownr, const Slicer &arraySection, const ArrayBase &array)
void | acbPut (rownr_t rownr, const ArrayBase &array)
| Put the array in a particular cell (i.e.
void | acbPutSlice (rownr_t rownr, const Slicer &arraySection, const ArrayBase &array)
| Put into a slice of an N-dimensional array in a particular cell.
void | acbPutSlice (rownr_t rownr, const Vector< Vector< Slice > > &arraySlices, const ArrayBase &arr)
void | acbPutColumn (const ArrayBase &array)
| Put the array of all values in the column.
void | acbPutColumn (const Slicer &arraySection, const ArrayBase &array)
| Put into subsections of the table arrays in the entire column.
void | acbPutColumn (const Vector< Vector< Slice > > &arraySlices, const ArrayBase &arr)
void | acbPutColumnRange (const Slicer &rowRange, const ArrayBase &arr)
| Put the array of some values in the column.
void | acbPutColumnCells (const RefRows &rownrs, const ArrayBase &arr)
void | acbPutColumnRange (const Slicer &rowRange, const Slicer &arraySection, const ArrayBase &arr)
| Put into subsection of the table arrays in some rows of the column.
void | acbPutColumnCells (const RefRows &rownrs, const Slicer &arraySection, const ArrayBase &arr)
void | acbPutColumnCells (const RefRows &rows, const Vector< Vector< Slice > > &arraySlices, const ArrayBase &source)
| Put various slices in the given rows.
void | acbPutColumnCells (const RefRows &rows, const ColumnSlicer &columnSlicer, const ArrayBase &source)
void | acbFillColumn (const ArrayBase &value)
| Put the same value in all cells of the column.
void | acbPutColumn (const ArrayColumnBase &that)
| Put the contents of that column into this one.
void | adaptShape (const IPosition &shp, ArrayBase &arr, Bool resize, Int64 rownr, const String &where) const
| Adapt the shape of the array if possible.
Bool | checkShape (const IPosition &expShape, const IPosition &arrShape, Bool noSlicing, Int64 rownr, const String &where) const
| Throw an exception if the array does not have the expected shape.
void | handleSlices (const Vector< Vector< Slice > > &slices, BaseSlicesFunctor &functor, const Slicer &slicer, const ArrayBase &array) const
| A common function used by all functions that can get or put irregular array slices.
Public Member Functions inherited from casacore::TableColumn
| TableColumn ()
| The default constructor creates a null object, i.e.
| TableColumn (const Table &, const String &columnName)
| Construct the object for a column in the table using its name.
| TableColumn (const Table &, uInt columnIndex)
| Construct the object for a column in the table using its index.
| TableColumn (const TableColumn &)
| Copy constructor (reference semantics).
virtual | ~TableColumn ()
TableColumn & | operator= (const TableColumn &)
| Assignment has reference semantics.
virtual TableColumn * | clone () const
| Clone the object.
void | reference (const TableColumn &)
| Change the reference to another column.
void | attach (const Table &table, const String &columnName)
| Attach a column to the object.
void | attach (const Table &table, uInt columnIndex)
Bool | isNull () const
| Test if the object is null, i.e.
void | throwIfNull () const
| Throw an exception if the object is null, i.e.
Bool | isWritable () const
| Test if the column can be written to, thus if the column and the underlying table can be written to.
Bool | isWritableAtAll () const
| Test if the column is writable at all (virtual columns might not be).
void | checkWritable () const
| Check if the column is writable and throw an exception if not.
const TableRecord & | keywordSet () const
| Get readonly access to the column keyword set.
TableRecord & | rwKeywordSet ()
| Get read/write access to the column keyword set.
const ColumnDesc & | columnDesc () const
| Get const access to the column description.
Table | table () const
| Get the Table object this column belongs to.
rownr_t | nrow () const
| Get the number of rows in the column.
Bool | canChangeShape () const
| Can the shape of an already existing non-FixedShape array be changed?
uInt | ndimColumn () const
| Get the global #dimensions of an array (ie.
IPosition | shapeColumn () const
| Get the global shape of an array (ie.
Bool | isDefined (rownr_t rownr) const
| Test if the given cell contains a defined value.
Bool | hasContent (rownr_t rownr=0) const
| Does the column has content in the given row (default is the first row)?
uInt | ndim (rownr_t rownr) const
| Get the #dimensions of an array in a particular cell.
IPosition | shape (rownr_t rownr) const
| Get the shape of an array in a particular cell.
IPosition | tileShape (rownr_t rownr) const
| Get the tile shape of an array in a particular cell.
void | getScalar (rownr_t rownr, Bool &value) const
| Get the value of a scalar in the given row.
void | getScalar (rownr_t rownr, uChar &value) const
void | getScalar (rownr_t rownr, Short &value) const
void | getScalar (rownr_t rownr, uShort &value) const
void | getScalar (rownr_t rownr, Int &value) const
void | getScalar (rownr_t rownr, uInt &value) const
void | getScalar (rownr_t rownr, Int64 &value) const
void | getScalar (rownr_t rownr, float &value) const
void | getScalar (rownr_t rownr, double &value) const
void | getScalar (rownr_t rownr, Complex &value) const
void | getScalar (rownr_t rownr, DComplex &value) const
void | getScalar (rownr_t rownr, String &value) const
Bool | asBool (rownr_t rownr) const
| Get the value from the row and convert it to the required type.
uChar | asuChar (rownr_t rownr) const
Short | asShort (rownr_t rownr) const
uShort | asuShort (rownr_t rownr) const
Int | asInt (rownr_t rownr) const
uInt | asuInt (rownr_t rownr) const
Int64 | asInt64 (rownr_t rownr) const
float | asfloat (rownr_t rownr) const
double | asdouble (rownr_t rownr) const
Complex | asComplex (rownr_t rownr) const
DComplex | asDComplex (rownr_t rownr) const
String | asString (rownr_t rownr) const
void | getScalarValue (rownr_t rownr, Bool *value, const String &) const
| Get the value of a scalar in the given row.
void | getScalarValue (rownr_t rownr, uChar *value, const String &) const
void | getScalarValue (rownr_t rownr, Short *value, const String &) const
void | getScalarValue (rownr_t rownr, uShort *value, const String &) const
void | getScalarValue (rownr_t rownr, Int *value, const String &) const
void | getScalarValue (rownr_t rownr, uInt *value, const String &) const
void | getScalarValue (rownr_t rownr, Int64 *value, const String &) const
void | getScalarValue (rownr_t rownr, float *value, const String &) const
void | getScalarValue (rownr_t rownr, double *value, const String &) const
void | getScalarValue (rownr_t rownr, Complex *value, const String &) const
void | getScalarValue (rownr_t rownr, DComplex *value, const String &) const
void | getScalarValue (rownr_t rownr, String *value, const String &) const
void | getScalarValue (rownr_t rownr, void *value, const String &dataTypeId) const
void | put (rownr_t rownr, const TableColumn &that, Bool preserveTileShape=False)
| Copy the value of a cell of that column to a cell of this column.
virtual void | put (rownr_t thisRownr, const TableColumn &that, rownr_t thatRownr, Bool preserveTileShape=False)
| Use possibly different row numbers for that (i.e.
void | putColumn (const TableColumn &that)
| Copy the values of that column to this column.
void | putScalar (rownr_t rownr, const Bool &value)
| Put the value of a scalar in the given row.
void | putScalar (rownr_t rownr, const uChar &value)
void | putScalar (rownr_t rownr, const Short &value)
void | putScalar (rownr_t rownr, const uShort &value)
void | putScalar (rownr_t rownr, const Int &value)
void | putScalar (rownr_t rownr, const uInt &value)
void | putScalar (rownr_t rownr, const Int64 &value)
void | putScalar (rownr_t rownr, const float &value)
void | putScalar (rownr_t rownr, const double &value)
void | putScalar (rownr_t rownr, const Complex &value)
void | putScalar (rownr_t rownr, const DComplex &value)
void | putScalar (rownr_t rownr, const String &value)
void | putScalar (rownr_t rownr, const Char *value)
void | checkRowNumber (rownr_t rownr) const
| Check if the row number is valid.
void | setMaximumCacheSize (uInt nbytes) const
| Set the maximum cache size (in bytes) to be used by a storage manager.

## Additional Inherited Members

Protected Member Functions inherited from casacore::TableColumn
BaseColumn * | baseColPtr () const
| Get the baseColPtr_p of this TableColumn object.
BaseColumn * | baseColPtr (const TableColumn &that) const
| Get the baseColPtr_p of another TableColumn object.
Protected Attributes inherited from casacore::TableColumn
BaseTable * | baseTabPtr_p
BaseColumn * | baseColPtr_p
const ColumnCache * | colCachePtr_p
Bool | canChangeShape_p
Bool | isColWritable_p

## Detailed Description

Read and write access to an array table column with arbitrary data type

### Intended use:

Public interface

### Review Status

Reviewed By:
  dschieb
Date Reviewed:
  1994/08/10
Test programs:
  none

### Prerequisite

- Table
- TableColumn

### Etymology

ArrayColumn<T> gives read and write access to an column in a table containing an array with data type T.

### Synopsis

ArrayColumnBase is the base class of the templated class ArrayColumn which allows readonly access to a column containing arrays with an arbitrary data type. It can handle direct as well as indirect arrays.

All get and put functions are implemented in this base class as non-templated functions. Type-specific operations are done by means of virtual functions in the Array classes.

### Example

See module Tables.

Definition at line 81 of file ArrayColumnBase.h.

## Constructor & Destructor Documentation

## ArrayColumnBase() [1/4]

casacore::ArrayColumnBase::ArrayColumnBase | ( |  | ) |

The default constructor creates a null object, i.e.

it does not reference a table column.

Referenced by acbPutColumn(), ArrayColumnBase(), operator=(), and reference().

## ArrayColumnBase() [2/4]

casacore::ArrayColumnBase::ArrayColumnBase | ( | const Table & | ,
|  | const String & | columnName )

Construct for the given column in the given table.

## ArrayColumnBase() [3/4]

casacore::ArrayColumnBase::ArrayColumnBase | ( | const TableColumn & | column | ) |

Construct from the given table column.

This constructor is useful if first a table column was constructed, its type is determined and thereafter used to construct the correct column object.

References casacore::TableColumn::TableColumn().

## ArrayColumnBase() [4/4]

casacore::ArrayColumnBase::ArrayColumnBase | ( | const ArrayColumnBase & |  | ) |

Copy constructor (reference semantics).

References ArrayColumnBase().

## ~ArrayColumnBase()

casacore::ArrayColumnBase::~ArrayColumnBase | ( |  | ) |

## Member Function Documentation

## acbFillColumn()

void casacore::ArrayColumnBase::acbFillColumn | ( | const ArrayBase & | value | ) |

Put the same value in all cells of the column.

References casacore::NewDelAllocator< T >::value.

## acbGet()

void casacore::ArrayColumnBase::acbGet | ( | rownr_t | rownr,
|  | ArrayBase & | array,
|  | Bool | resize ) const

Get the array value in a particular cell (i.e.

table row). The row numbers count from 0 until #rows-1.

References casacore::array.

## acbGetColumn() [1/3]

void casacore::ArrayColumnBase::acbGetColumn | ( | ArrayBase & | array,
|  | Bool | resize ) const

Get the array of all values in a column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim with the last dimension representing the number of rows. The arrays in the column must have the same shape in all cells.

References casacore::array.

## acbGetColumn() [2/3]

void casacore::ArrayColumnBase::acbGetColumn | ( | const Slicer & | arraySection,
|  | ArrayBase & | array,
|  | Bool | resize ) const

Get regular slices from all arrays in the column.

If the column contains n-dim arrays, the resulting array is (n+1)-dim. with the last dimension representing the number of rows and the other dimensions representing the shape of the slice. The arrays in the column must have the same shape in all cells.

References casacore::array.

## acbGetColumn() [3/3]

void casacore::ArrayColumnBase::acbGetColumn | ( | const Vector< Vector< Slice > > & | arraySection,
|  | ArrayBase & | array,
|  | Bool | resize ) const

Get irregular slices from all arrays in the column as given by the vectors of Slice objects.

The outer vector represents the array axes. A missing or empty axis means the entire axis. The inner vector represents the slices to take for each axis. For example, to get slices from 2-dim arrays:

Vector<Vector<Slice> > slices(2); // 2-dim
slices[1].resize (3); // 3 slices in 2nd dim
slices[1][0] = Slice(100,20);
slices[1][1] = Slice(200,18);
slices[1][2] = Slice(538,30,2);
// Get data. Vector of first axis is empty, thus entire axis is read.
Array<Complex> data = dataCol.getColumn (slices);
casacore::Array
Definition Array.h:155
casacore::Slice
Definition Slice.h:89
casacore::Vector
Definition Vector.h:82

If the column contains n-dim arrays, the resulting array is (n+1)-dim. with the last dimension representing the number of rows and the other dimensions representing the shape of the slice. The arrays in the column must have the same shape in all cells.

References casacore::array.

## acbGetColumnCells() [1/3]

void casacore::ArrayColumnBase::acbGetColumnCells | ( | const RefRows & | rownrs,
|  | ArrayBase & | arr,
|  | Bool | resize ) const

## acbGetColumnCells() [2/3]

void casacore::ArrayColumnBase::acbGetColumnCells | ( | const RefRows & | rownrs,
|  | const Slicer & | arraySection,
|  | ArrayBase & | arr,
|  | Bool | resize ) const

## acbGetColumnCells() [3/3]

void casacore::ArrayColumnBase::acbGetColumnCells | ( | const RefRows & | rows,
|  | const ColumnSlicer & | columnSlicer,
|  | ArrayBase & | destination,
|  | Bool | resize ) const

Get various slices from the given rows.

## acbGetColumnRange() [1/2]

void casacore::ArrayColumnBase::acbGetColumnRange | ( | const Slicer & | rowRange,
|  | ArrayBase & | arr,
|  | Bool | resize ) const

Get the array of some values in a column.

The Slicer object can be used to specify start, end (or length), and stride of the rows to get. If the column contains n-dim arrays, the resulting array is (n+1)-dim with the last dimension representing the number of rows in the slicer. The arrays in the column must have the same shape in all those cells.

## acbGetColumnRange() [2/2]

void casacore::ArrayColumnBase::acbGetColumnRange | ( | const Slicer & | rowRange,
|  | const Slicer & | arraySection,
|  | ArrayBase & | arr,
|  | Bool | resize ) const

Get slices from some arrays in a column.

The first Slicer object can be used to specify start, end (or length), and stride of the rows to get. The second Slicer object can be used to specify the slice to take from each array. If the column contains n-dim arrays, the resulting array is (n+1)-dim with the last dimension representing the number of rows in the slicer. The arrays in the column must have the same shape in all those cells.

## acbGetSlice() [1/2]

void casacore::ArrayColumnBase::acbGetSlice | ( | rownr_t | rownr,
|  | const Slicer & | arraySection,
|  | ArrayBase & | array,
|  | Bool | resize ) const

Get a slice of an N-dimensional array in a particular cell (i.e.

table row). The row numbers count from 0 until #rows-1. The dimensionality of the slice must match the dimensionality of the table array and the slice definition should not exceed the shape of the table array.

References casacore::array.

## acbGetSlice() [2/2]

void casacore::ArrayColumnBase::acbGetSlice | ( | rownr_t | rownr,
|  | const Vector< Vector< Slice > > & | arraySlices,
|  | ArrayBase & | arr,
|  | Bool | resize ) const

Get an irregular slice of an N-dimensional array in a particular cell (i.e.

table row) as given by the vectors of Slice objects. The outer vector represents the array axes. A missing or empty axis means the entire axis. The inner vector represents the slices to take for each axis. For example, to get slices from 2-dim arrays:

Vector<Vector<Slice> > slices(2); // 2-dim
slices[1].resize (3); // 3 slices in 2nd dim
slices[1][0] = Slice(100,20);
slices[1][1] = Slice(200,18);
slices[1][2] = Slice(538,30,2);
// Get data. Vector of first axis is empty, thus entire axis is read.
Array<Complex> data = dataCol.getColumn (slices);

If the column contains n-dim arrays, the resulting array is (n+1)-dim. with the last dimension representing the number of rows and the other dimensions representing the shape of the slice. The arrays in the column must have the same shape in all cells.

## acbPut()

void casacore::ArrayColumnBase::acbPut | ( | rownr_t | rownr,
|  | const ArrayBase & | array )

Put the array in a particular cell (i.e.

table row). The row numbers count from 0 until #rows-1. If the shape of the table array in that cell has not already been defined, it will be defined implicitly.

References casacore::array.

## acbPutColumn() [1/4]

void casacore::ArrayColumnBase::acbPutColumn | ( | const ArrayBase & | array | ) |

Put the array of all values in the column.

If the column contains n-dim arrays, the source array must be (n+1)-dim with the last dimension representing the number of rows.

References casacore::array.

## acbPutColumn() [2/4]

void casacore::ArrayColumnBase::acbPutColumn | ( | const ArrayColumnBase & | that | ) |

Put the contents of that column into this one.

References ArrayColumnBase().

## acbPutColumn() [3/4]

void casacore::ArrayColumnBase::acbPutColumn | ( | const Slicer & | arraySection,
|  | const ArrayBase & | array )

Put into subsections of the table arrays in the entire column.

If the column contains n-dim arrays, the source array is (n+1)-dim with the last dimension representing the number of rows and other dimensions representing the shape of the slice. The dimensionality of the slice must match the dimensionality of the table array, thus must be n-dim. Also the slice definition should not exceed the shape of the table arrays.

References casacore::array.

## acbPutColumn() [4/4]

void casacore::ArrayColumnBase::acbPutColumn | ( | const Vector< Vector< Slice > > & | arraySlices,
|  | const ArrayBase & | arr )

## acbPutColumnCells() [1/4]

void casacore::ArrayColumnBase::acbPutColumnCells | ( | const RefRows & | rownrs,
|  | const ArrayBase & | arr )

## acbPutColumnCells() [2/4]

void casacore::ArrayColumnBase::acbPutColumnCells | ( | const RefRows & | rownrs,
|  | const Slicer & | arraySection,
|  | const ArrayBase & | arr )

## acbPutColumnCells() [3/4]

void casacore::ArrayColumnBase::acbPutColumnCells | ( | const RefRows & | rows,
|  | const ColumnSlicer & | columnSlicer,
|  | const ArrayBase & | source )

## acbPutColumnCells() [4/4]

void casacore::ArrayColumnBase::acbPutColumnCells | ( | const RefRows & | rows,
|  | const Vector< Vector< Slice > > & | arraySlices,
|  | const ArrayBase & | source )

Put various slices in the given rows.

## acbPutColumnRange() [1/2]

void casacore::ArrayColumnBase::acbPutColumnRange | ( | const Slicer & | rowRange,
|  | const ArrayBase & | arr )

Put the array of some values in the column.

The Slicer object can be used to specify start, end (or length), and stride of the rows to put. If the column contains n-dim arrays, the source array must be (n+1)-dim with the last dimension representing the number of rows in the slicer.

## acbPutColumnRange() [2/2]

void casacore::ArrayColumnBase::acbPutColumnRange | ( | const Slicer & | rowRange,
|  | const Slicer & | arraySection,
|  | const ArrayBase & | arr )

Put into subsection of the table arrays in some rows of the column.

The first Slicer object can be used to specify start, end (or length), and stride of the rows to put. The second Slicer object can be used to specify the slice to take from each array. If the column contains n-dim arrays, the source array must be (n+1)-dim with the last dimension representing the number of rows in the slicer.

## acbPutSlice() [1/2]

void casacore::ArrayColumnBase::acbPutSlice | ( | rownr_t | rownr,
|  | const Slicer & | arraySection,
|  | const ArrayBase & | array )

Put into a slice of an N-dimensional array in a particular cell.

The row numbers count from 0 until #rows-1. The shape of the table array must have been defined. The dimensionality of the slice must match the dimensionality of the table array and the slice definition should not exceed the shape of the table array.

References casacore::array.

## acbPutSlice() [2/2]

void casacore::ArrayColumnBase::acbPutSlice | ( | rownr_t | rownr,
|  | const Vector< Vector< Slice > > & | arraySlices,
|  | const ArrayBase & | arr )

## adaptShape()

void casacore::ArrayColumnBase::adaptShape | ( | const IPosition & | shp,
|  | ArrayBase & | arr,
|  | Bool | resize,
|  | Int64 | rownr,
|  | const String & | where ) const

Adapt the shape of the array if possible.

If the array is empty or if resize=True, the array is resized if needed. Otherwise checkShape is used to throw an exception if not conforming.

## baseGet()

void casacore::ArrayColumnBase::baseGet | ( | rownr_t | rownr,
|  | ArrayBase & | array ) const

inline

Counterparts of the acbGet() functions below not checking shapes, etc.

They are faster and can be used for performance reasons if one knows for sure that the arguments are correct. E.g., they are used internally in virtual column engines.

Definition at line 130 of file ArrayColumnBase.h.

References casacore::array, and casacore::TableColumn::baseColPtr_p.

## baseGetSlice()

void casacore::ArrayColumnBase::baseGetSlice | ( | rownr_t | rownr,
|  | const Slicer & | arraySection,
|  | ArrayBase & | array ) const

inline

Definition at line 132 of file ArrayColumnBase.h.

References casacore::array, and casacore::TableColumn::baseColPtr_p.

## basePut()

void casacore::ArrayColumnBase::basePut | ( | rownr_t | rownr,
|  | const ArrayBase & | array )

inline

Counterparts of the acbPut() functions below not checking shapes, etc.

They are faster and can be used for performance reasons if one knows for sure that the arguments are correct. E.g., they are used internally in virtual column engines.

Definition at line 258 of file ArrayColumnBase.h.

References casacore::array, and casacore::TableColumn::baseColPtr_p.

## basePutSlice()

void casacore::ArrayColumnBase::basePutSlice | ( | rownr_t | rownr,
|  | const Slicer & | arraySection,
|  | const ArrayBase & | array )

inline

Definition at line 260 of file ArrayColumnBase.h.

References casacore::array, and casacore::TableColumn::baseColPtr_p.

## checkShape()

Bool casacore::ArrayColumnBase::checkShape | ( | const IPosition & | expShape,
|  | const IPosition & | arrShape,
|  | Bool | noSlicing,
|  | Int64 | rownr,
|  | const String & | where ) const

Throw an exception if the array does not have the expected shape.

However, False is returned if noSlicing and canChangeShape_p are True (meaning no slices are put and the shape of a full row can change). The column name is made part of the error message, as well as the rownr if it is not negative (meaning a put of a column).

## handleSlices()

void casacore::ArrayColumnBase::handleSlices | ( | const Vector< Vector< Slice > > & | slices,
|  | BaseSlicesFunctor & | functor,
|  | const Slicer & | slicer,
|  | const ArrayBase & | array ) const

A common function used by all functions that can get or put irregular array slices.

The functor performs the get or put operation.

References casacore::array.

## ndim()

uInt casacore::ArrayColumnBase::ndim | ( | rownr_t | rownr | ) | const

inline

Get the #dimensions of an array in a particular cell.

If the cell does not contain an array, 0 is returned. Use the function isDefined to test if the cell contains an array.

Definition at line 116 of file ArrayColumnBase.h.

References casacore::TableColumn::baseColPtr_p, and TABLECOLUMNCHECKROW.

## operator=()

ArrayColumnBase & casacore::ArrayColumnBase::operator= | ( | const ArrayColumnBase & |  | ) |

Assignment uses reference semantics, thus works the same as function reference.

References ArrayColumnBase().

## reference()

void casacore::ArrayColumnBase::reference | ( | const ArrayColumnBase & |  | ) |

Change the reference to another column.

This is in fact an assignment operator with reference semantics. It removes the reference to the current column and creates a reference to the column referenced in the other object. It will handle null objects correctly.

References ArrayColumnBase().

## setShape() [1/2]

void casacore::ArrayColumnBase::setShape | ( | rownr_t | rownr,
|  | const IPosition & | shape )

Set the shape of the array in the given row.

Setting the shape is needed if the array is put in slices, otherwise the table system would not know the shape.

References shape().

## setShape() [2/2]

void casacore::ArrayColumnBase::setShape | ( | rownr_t | rownr,
|  | const IPosition & | shape,
|  | const IPosition & | tileShape )

Try to store the array in a tiled way using the given tile shape.

References shape(), and casacore::TableColumn::tileShape().

## shape()

IPosition casacore::ArrayColumnBase::shape | ( | rownr_t | rownr | ) | const

inline

Get the shape of an array in a particular cell.

If the cell does not contain an array, a 0-dim shape is returned. Use the function isDefined to test if the cell contains an array.

Definition at line 122 of file ArrayColumnBase.h.

References casacore::TableColumn::baseColPtr_p, and TABLECOLUMNCHECKROW.

Referenced by setShape(), and setShape().

The documentation for this class was generated from the following file:

- tables/Tables/ArrayColumnBase.h